package me.unurled.raxen.commands.player;

import static me.unurled.raxen.utils.Utils.colorTextComp;
import static me.unurled.raxen.utils.Utils.error;

import java.util.HashMap;
import java.util.List;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.classes.Class;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class ClassCommand implements TabExecutor {

    private Raxen main;

    /**
     * the Command to choose the class
     * @param main
     */
    public ClassCommand(Raxen main) {
        this.main = main;
    }

    @Override
    public boolean onCommand(
        @NotNull CommandSender sender,
        @NotNull Command command,
        @NotNull String label,
        @NotNull String[] args
    ) {
        if (!(sender instanceof Player)) {
            error(
                (Raxen) Bukkit.getPluginManager().getPlugin("Raxen"),
                "The console can't execute this Command!"
            );
            return true;
        }
        Player player = (Player) sender;
        Inventory inv = Bukkit.createInventory(
            null,
            9,
            colorTextComp("<grey>Choose your class</grey>")
        );
        HashMap<String, Class> classes = main
            .getManager()
            .getPlayerManager()
            .getClasses();
        if (classes.size() > 10) {
            if (classes.size() > 55) {
                inv =
                    Bukkit.createInventory(
                        null,
                        classes.size(),
                        colorTextComp("<grey>Choose your class</grey>")
                    );
            }
        }
        for (Class clas : classes.values()) {
            ItemStack item = clas.getPlaceHolder();
            inv.addItem(item);
        }
        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(
        @NotNull CommandSender sender,
        @NotNull Command command,
        @NotNull String alias,
        @NotNull String[] args
    ) {
        return null;
    }
}
