package me.unurled.raxen.commands.player;

import static me.unurled.raxen.utils.Utils.colorString;
import static me.unurled.raxen.utils.Utils.error;
import static me.unurled.raxen.utils.Utils.msgPlayer;

import java.util.List;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class StorageCommand implements TabExecutor {

    private PlayerManager playerManager;

    @Override
    public boolean onCommand(
        @NotNull CommandSender sender,
        @NotNull Command command,
        @NotNull String label,
        @NotNull String[] args
    ) {
        if (!(sender instanceof Player)) {
            error(
                (Raxen) Bukkit.getPluginManager().getPlugin("Raxen"),
                "The console can't execute this Command!"
            );
            return true;
        }
        Player player = (Player) sender;
        Inventory inv;
        playerManager =
            ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager()
                .getPlayerManager();
        switch (args.length) {
            case 0:
                if (playerManager.getRaxenPlayer(player).getStorage() == null) {
                    inv =
                        playerManager
                            .getRaxenPlayer(player)
                            .createStorage()
                            .getEc()
                            .getEc();
                } else {
                    inv =
                        playerManager
                            .getRaxenPlayer(player)
                            .getStorage()
                            .getEc()
                            .getEc();
                }
                player.openInventory(inv);
                break;
            case 1:
                Player p = Bukkit.getPlayer(args[0]);
                if (p == null) {
                    msgPlayer(
                        player,
                        colorString(
                            "<red>You can't open the Storage of an unknown Player."
                        )
                    );
                    return true;
                }
                inv =
                    playerManager
                        .getRaxenPlayer(player)
                        .getStorage()
                        .getEc()
                        .getEc();
                player.openInventory(inv);
                break;
        }
        return true;
    }

    @Override
    public @Nullable List<String> onTabComplete(
        @NotNull CommandSender sender,
        @NotNull Command command,
        @NotNull String alias,
        @NotNull String[] args
    ) {
        return null;
    }
}
