package me.unurled.raxen.components.entity.other.custom;

import static me.unurled.raxen.utils.Utils.colorString;

import java.util.UUID;
import lombok.Getter;
import lombok.Setter;
import me.unurled.raxen.Raxen;

public abstract class Entity implements org.bukkit.entity.Entity {

    private java.util.UUID uuid;

    private final String name;

    @Getter
    private Integer level;

    @Setter
    private Double health;

    @Getter
    @Setter
    private Double strength;

    @Getter
    @Setter
    private Double defense;

    @Getter
    @Setter
    private Double speed;

    @Getter
    @Setter
    private Double maxHealth;

    @Getter
    @Setter
    private boolean isHostile;

    @Getter
    @Setter
    private double xp;

    public Entity(
        String name,
        Integer level,
        Double maxHealth,
        Double strength,
        Double defense,
        Double speed,
        boolean isHostile,
        double xp
    ) {
        this.name = name;
        this.level = level;
        this.health = maxHealth;
        this.strength = strength;
        this.defense = defense;
        this.speed = speed;
        this.maxHealth = maxHealth;
        this.isHostile = isHostile;
        this.uuid = UUID.randomUUID();
        this.xp = xp;
    }

    public void register(Raxen main) {
//        main.getManager().getEntityManager().entities.put(name, this);
    }

    public String getName() {
        return "<white>" + name;
    }

    public String getFullName(Entity e) {
        if (isHostile) {
            return colorString(
                getColorLevel() +
                    "<white>⚔️" +
                    getName() +
                    "<red>" +
                    health +
                    "<white>/<white/>" +
                    maxHealth
            );
        } else {
            return colorString(
                getColorLevel() +
                    "<white>❤️" +
                    getName() +
                    "<red>" +
                    health +
                    "<white>/<white/>" +
                    maxHealth
            );
        }
    }

    public String getColorLevel() {
        return level.toString();
    }

    public Double getHealth() {
        Double health = 0.0;

        return health;
    }

    public double getDamage() {
        // TODO: calculate properly the damage
        return strength;
    }
}
