package me.unurled.raxen.components.entity.player;

import static me.unurled.raxen.utils.Utils.colorComp;
import static me.unurled.raxen.utils.Utils.debug;
import static me.unurled.raxen.utils.Utils.log;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

public class PlayerUtils {

    public static void updateSkills(Raxen main, Player player) {
        PlayerManager pm = main.getManager().getPlayerManager();
        int maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemStrength, maxMana, mana, itemMana, luck, itemLuck;
        defense = pm.getDefense().get(player);
        maxMana = pm.getMaxMana().get(player);
        itemDefense = pm.getItemDefense().get(player);
        health = pm.getHealth().get(player);
        itemHealth = pm.getItemHealth().get(player);
        mana = pm.getMana().get(player);
        speed = pm.getSpeed().get(player);
        itemLuck = pm.getItemLuck().get(player);
        strength = pm.getStrength().get(player);
        luck = pm.getLuck().get(player);
        maxHealth = pm.getMaxHealth().get(player);
        itemStrength = pm.getItemStrength().get(player);
        itemSpeed = pm.getItemSpeed().get(player);
        itemMana = pm.getItemMana().get(player);
        double hearts = maxHealth + itemHealth;
        double heart = 10;
        if (hearts > 125 && hearts < 165) {
            heart = 11;
        } else if (hearts > 165 && hearts <= 230) {
            heart = 12;
        } else if (hearts > 230 && hearts <= 300) {
            heart = 13;
        } else if (hearts > 300 && hearts <= 400) {
            heart = 14;
        } else if (hearts > 400 && hearts <= 500) {
            heart = 15;
        } else if (hearts > 500 && hearts <= 650) {
            heart = 16;
        } else if (hearts > 650 && hearts <= 800) {
            heart = 17;
        } else if (hearts > 800 && hearts <= 1000) {
            heart = 18;
        } else if (hearts > 1000 && hearts <= 1250) {
            heart = 19;
        } else if (hearts > 1250) {
            heart = 20;
        }
        log(heart + " " + hearts);
        player
            .getAttribute(Attribute.GENERIC_MAX_HEALTH)
            .setBaseValue(heart * 2);
        player.setWalkSpeed((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        player.setFlySpeed((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        debug(
            "Player " + player.getName(),
            "Speed " + (speed + itemSpeed),
            "Health " + (health + itemHealth) + " Max Health " + maxHealth,
            "Defense " + (defense + itemDefense),
            "Strength " + (strength + itemStrength),
            "Luck " + (luck + itemLuck),
            "Mana " + (mana + itemMana) + " Max Mana " + maxMana
        );
        pm.updateActionBar(player);
    }

    public static BukkitTask actionBarPlayer(
        Raxen main,
        PlayerManager pm,
        Player player
    ) {
        return new BukkitRunnable() {
            @Override
            public void run() {
                player.sendActionBar(
                    colorComp(
                        "<red>" +
                            pm.getHealth().get(player) +
                            "/" +
                            pm.getMaxHealth().get(player) +
                            "❤</red>  <aqua>" +
                            pm.getMana().get(player) +
                            "/" +
                            pm.getMaxMana().get(player) +
                            "</aqua>"
                    )
                );
            }
        }
            .runTaskTimerAsynchronously(main, 10, 20);
    }
}
