package me.unurled.raxen.components.glyph;

import org.bukkit.configuration.ConfigurationSection;

public class GlyphParser {

    private final ConfigurationSection section;

    public GlyphParser(ConfigurationSection section) {
        this.section = section;
        if (section.isConfigurationSection("Pack")) {
            ConfigurationSection packSection = section.getConfigurationSection("Pack");
            applyConfig(buildGlyph());
        }
    }

    public GlyphBuilder buildGlyph() {
        return buildGlyph(section.contains("char") ? section.getString("char") : null);
    }

    public GlyphBuilder buildGlyph(String car) {
        GlyphBuilder glyph = null;
        if (car != null) {
            glyph = new GlyphBuilder(car);
        }
        return glyph;
    }

    private GlyphBuilder applyConfig(GlyphBuilder glyph) {
        if (section.contains("Pack")) {
            ConfigurationSection s = section.getConfigurationSection("Pack");
            if (s.contains("model")) {
                glyph.model(s.getString("model"));
            }
            if (s.contains("texture")) {
                glyph.texture(s.getString("texture"));
            }
            if (s.contains("placeholder")) {
                glyph.placeholder(s.getString("placeholder"));
            }
        }
        return glyph;
    }
}
