package me.unurled.raxen.components.gui;

import static me.unurled.raxen.utils.Utils.fillGreyPane;

import java.util.HashMap;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.PlayerUtils;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class ItemListGui implements Listener {

    private Raxen main;

    @Getter
    private Inventory inv = Bukkit.createInventory(
        null,
        54,
        Component.text("Item List")
    );

    private HashMap<String, ItemStack> itlist;

    public ItemListGui(Raxen main) {
        this.main = main;
        this.itlist = this.main.getManager().getItemManager().getList();
    }

    public Inventory getInventories(int page) {
        int item = -1;
        int number = 54 * (page - 1);
        int number_final = number + 54;

        for (ItemStack it : itlist.values()) {
            item++;
            if (item >= number && item < number_final) {
                inv.setItem(item - number, it);
            }
        }
        fillGreyPane(inv);
        return inv;
    }

    @EventHandler
    public void clickInventory(InventoryClickEvent e) {
        Player player = (Player) e.getWhoClicked();
        Inventory einv = e.getClickedInventory();
        if (einv == inv) {
            if (
                e.getCurrentItem() != null &&
                    e.getCurrentItem().getType() != Material.AIR
            ) {
                Integer slot = e.getSlot();
                ItemStack clicked;
                //if (player.getInventory().firstEmpty() == -1) {
                //add to stash
                //}
                player.getInventory().addItem(e.getCurrentItem());
                player.closeInventory();
                player.playSound(player, Sound.UI_BUTTON_CLICK, 1, 0);
                PlayerUtils.updateSkills(main, player);
            }
        }
    }

    public void openInventory(Player player, int page) {
        inv = getInventories(page);
        player.openInventory(inv);
    }
}
