package me.unurled.raxen.components.items;

import java.util.List;
import me.unurled.raxen.utils.Utils;
import org.bukkit.Material;
import org.bukkit.configuration.ConfigurationSection;

public class ItemParser {

    private final ConfigurationSection section;
    private Material type;

    public ItemParser(ConfigurationSection section) {
        this.section = section;
        type = Material.getMaterial(section.getString("material", "PAPER"));
        if (section.isConfigurationSection("Pack")) {
            ConfigurationSection packSection = section.getConfigurationSection("Pack");
            // TODO: Parse pack section
//            item.modelData(section.getString("Pack.model", null), section.getInt("Pack.custom_model_data", 0));

        }
    }

    public ItemBuilder buildItem() {
        return buildItem(section.contains("name") ? section.getString("name") : null);
    }

    public ItemBuilder buildItem(String name) {
        ItemBuilder item;
        item = new ItemBuilder(type);
        if (name != null) {
            item.displayName(name);
        }
        return item;
    }

    private ItemBuilder applyConfig(ItemBuilder item) {
        if (section.contains("lore")) {
            List<String> lore = section.getStringList("lore");
            item.lore(lore);
        }

        if (section.contains("color")) {
            item.color(Utils.color(section.getString("color", "FFFFFF")));
        }

        if (section.contains("Pack")) {
            item.modelData(section.getString("Pack.model", null), section.getInt("Pack.custom_model_data", 0));
        }
        return item;
    }
}
