package me.unurled.raxen.components.items.custom.weapon;

import static me.unurled.raxen.utils.Utils.colorTextComp;

import de.tr7zw.nbtapi.NBT;
import java.util.ArrayList;
import java.util.List;
import lombok.Getter;
import me.unurled.raxen.components.items.NBTNames;
import me.unurled.raxen.components.items.custom.Item;
import me.unurled.raxen.components.items.custom.ItemClass;
import me.unurled.raxen.components.items.custom.ItemTypes;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class CombatKnife extends Item {

    @Getter
    ItemStack item;

    static final String NAME = "Combat Knife";
    static final String ID = "COMBAT_KNIFE";

    static final ItemClass ITEM_CLASS = ItemClass.F;
    static final ItemTypes ITEM_TYPES = ItemTypes.WEAPON;

    public ItemStack buildItem() {
        item = new ItemStack(Material.IRON_SWORD);
        ItemMeta itm = item.getItemMeta();
        itm.displayName(colorTextComp("<aqua>" + NAME));
        itm.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        itm.setUnbreakable(true);
        List<Component> lore = new ArrayList<>();
        lore.add(
            colorTextComp(
                "<grey>A simple combat knife with a serrated edge.</grey>"
            )
        );
        itm.setCustomModelData(1);
        itm.lore(lore);
        item.setItemMeta(itm);
        NBT.modify(
            item,
            nbt -> {
                nbt.setString(NBTNames.ID, ID);
                nbt.setString(NBTNames.ITEM_TYPE, ITEM_TYPES.toString());
                nbt.setString(NBTNames.ITEM_CLASS, ITEM_CLASS.toString());
                nbt.setInteger(NBTNames.STRENGTH, 20);
            }
        );
        return item;
    }
}
