package me.unurled.raxen.components.items.custom.weapon;

import static me.unurled.raxen.utils.Utils.colorTextComp;

import de.tr7zw.nbtapi.NBTItem;
import java.util.ArrayList;
import java.util.List;
import lombok.Getter;
import me.unurled.raxen.components.items.NBTNames;
import me.unurled.raxen.components.items.custom.Item;
import me.unurled.raxen.components.items.custom.ItemClass;
import me.unurled.raxen.components.items.custom.ItemTypes;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class Dagger extends Item {

    @Getter
    ItemStack item;

    static final String NAME = "Dager";
    static final String ID = "DAGER";

    static final ItemClass ITEM_CLASS = ItemClass.F;
    static final ItemTypes ITEM_TYPES = ItemTypes.WEAPON;

    public ItemStack buildItem() {
        item = new ItemStack(Material.IRON_SWORD);
        ItemMeta itm = item.getItemMeta();
        itm.displayName(colorTextComp("<aqua>" + NAME));
        itm.addEnchant(Enchantment.PROTECTION_ENVIRONMENTAL, 1, false);
        itm.addItemFlags(ItemFlag.HIDE_ATTRIBUTES, ItemFlag.HIDE_ENCHANTS);
        itm.setUnbreakable(true);
        List<Component> lore = new ArrayList<>();
        lore.add(Component.text("hallooo"));
        itm.lore(lore);
        item.setItemMeta(itm);
        NBTItem nbti = new NBTItem(item);
        nbti.setString(NBTNames.ID, ID);
        nbti.setInteger(NBTNames.SPEED, 100);
        nbti.setInteger(NBTNames.STRENGTH, 50);
        nbti.setString(NBTNames.CUSTOM_ABILITY, "throwing_dager");
        nbti.setDouble(NBTNames.DROP_RATE, 50.0);
        item = nbti.getItem();
        return item;
    }
}
