package me.unurled.raxen.components.tutorial;

import static me.unurled.raxen.utils.Utils.colorTextComp;
import static me.unurled.raxen.utils.Utils.log;
import static me.unurled.raxen.utils.Utils.msgPlayer;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.RaxenPlayer;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffectType;

public class Tutorial {

    @Getter
    private double x;
    @Getter
    private double y;
    @Getter
    private double z;

    @Getter
    private int step = 0;

    @Getter
    private World world;

    public Tutorial() {
        this.step = 0;
    }

    public Tutorial(int step) {
        this.step = step;
    }

    public Tutorial(int step, double x, double y, double z, World world) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.step = step;
        this.world = world;
    }

    public void startTutorial(Player player, Location loc) {
        x = loc.getX();
        y = loc.getY();
        z = loc.getZ();
        world = loc.getWorld();
        Raxen main = (Raxen) Bukkit.getPluginManager().getPlugin("Raxen");
        RaxenPlayer rxPlayer = main.getManager().getPlayerManager().getRaxenPlayer(player);
        rxPlayer.setInTutorial(true);
        step = 1;
        player.addPotionEffect(PotionEffectType.BLINDNESS.createEffect(100, 10));
        player.teleport(
            new Location(world, 15.82, 74.00, 117.21, 899.21F, 0.90f));
        msgPlayer(player, colorTextComp("<green>Welcome to the tutorial!"));
        // Hologram holo = api.createHologram(new Location(world, 15.5, 76.00, 112.5, 179.21f, 0.90f));
    }

    public void stopTutorial() {
        log("needs to be implemented");
    }

    public void nextStep() {
        log("needs to be implemented");
    }

    public void previousStep() {
        log("needs to be implemented");
    }
}
