package me.unurled.raxen.listener.entity;

import static me.unurled.raxen.utils.Utils.debug;

import java.util.Objects;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.other.EntityNamespacedKey;
import me.unurled.raxen.components.entity.other.MobData;
import me.unurled.raxen.components.entity.player.RaxenPlayer;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByBlockEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.metadata.Metadatable;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.bukkit.projectiles.ProjectileSource;

public class DamageEntity implements Listener {

    private Raxen main;
    private EntityNamespacedKey entityNamespacedKey;

    public DamageEntity(Raxen main) {
        this.main = main;
        this.entityNamespacedKey = new EntityNamespacedKey(main);
    }

    /**
     * fired when an entity is damaged by something TODO: calculate damage and apply it to the
     * entity
     *
     * @param e event
     */
    @EventHandler
    public void entityDamage(EntityDamageEvent e) {
        e.setCancelled(true);
        e.setDamage(0);
        e.getEntity().setFireTicks(0);
        if (e instanceof EntityDamageByEntityEvent) {
            EntityDamageByEntityEvent ev2 = (EntityDamageByEntityEvent) e;
            ev2.setCancelled(true);
            Entity attacker = ev2.getDamager();
            Entity defender = ev2.getEntity();
            if (attacker instanceof Player) {
                PlayerManager pm = main.getManager().getPlayerManager();
                if (defender instanceof Player) {
                    // attack between players
                    RaxenPlayer rx = pm.getRaxenPlayer((Player) attacker);
                    RaxenPlayer rx2 = pm.getRaxenPlayer((Player) defender);
                    if (rx != null && rx2 != null) {
                        rx.attackPlayer(rx2);
                    }
                } else {
                    // attack between player and mob
                    RaxenPlayer rx = pm.getRaxenPlayer((Player) attacker);
                    MobData re = main.getManager().getEntityManager().getSpawnedMob().get(
                        defender.getUniqueId());
                    if (rx != null) {
                        rx.attackMob(re);
                    }
                }
            } else if (attacker instanceof Projectile) {
                boolean projectile = true;
                ProjectileSource source = ((Projectile) attacker).getShooter();
                double rpgKnockback = -1;
                int rpgDamage = -1;
                if (attacker != null) {
                    Metadatable sourceMeta = (Metadatable) attacker;
                    // TODO: check metadata
                }
                if (source == defender) {
                    attacker.remove();
                    return;
                }
                if (source instanceof Player) {
                    RaxenPlayer rx = main.getManager().getPlayerManager().getRaxenPlayer(
                        (Player) source);
                    if (defender instanceof Player) {
                        RaxenPlayer rx2 = main.getManager().getPlayerManager().getRaxenPlayer(
                            (Player) defender);
                        // range attack between players
                        if (rpgKnockback >= 0) {
                            rx.attackPlayer(rx2, rpgDamage, projectile, rpgKnockback);
                        } else {
                            rx.attackPlayer(rx2, rpgDamage, projectile);
                        }
                    } else {
                        MobData mb = main.getManager().getEntityManager().getSpawnedMob().get(
                            defender.getUniqueId());
                        if (rx != null && mb != null) {
                            if (rpgKnockback >= 0) {
                                rx.attackMob(mb, rpgKnockback, rpgDamage, projectile);
                            } else {
                                rx.attackMob(mb, rpgDamage, projectile);
                            }
                        }
                        // range attack between player and mob
                    }
                } else {
                    if (defender instanceof Player) {
                        MobData a = main.getManager().getEntityManager().getSpawnedMob().get(
                            attacker.getUniqueId());
                        RaxenPlayer d = main.getManager().getPlayerManager().getRaxenPlayer(
                            (Player) defender);
                        if (a != null && d != null) {
                            a.attack(d, rpgDamage, projectile);
                        }
                        // range attack between mob and player
                    } else {
                        // range attack between mobs
                    }
                }
                attacker.remove();
            } else {
                if (defender instanceof Player) {
                    MobData a = main.getManager().getEntityManager().getSpawnedMob().get(
                        attacker.getUniqueId());
                    RaxenPlayer d = main.getManager().getPlayerManager().getRaxenPlayer(
                        (Player) defender);
                    if (a != null && d != null) {
                        a.attack(d);
                    }
                    // attack between mob and player
                } else {
                    // attack between mobs
                }
            }
        }

    }

    /**
     * fired when an entity is damaged by another entity calculates the damage and apply it to the
     * entity
     *
     * @param e
     */
    @Deprecated
    // @EventHandler
    public void entityDamageByEntity(EntityDamageByEntityEvent e) {
        if (
            !(e.getEntity() instanceof LivingEntity) ||
                !(e.getDamager() instanceof LivingEntity)
        ) {
            debug(
                "Not Living Entity, Some block falling shit or block entities"
            );
        } else {
            e.setCancelled(true);
            e.setDamage(0);
            Integer damage = 1;
            Integer strength = 0;
            Integer itemStrength = 0;
            Integer defense = 0;
            Integer itemDefense = 0;
            Integer health = 0;
            Integer itemHealth = 0;
            Integer initDamage = 0;
            PlayerManager pm =
                (
                    (Raxen) Objects.requireNonNull(
                        Bukkit.getPluginManager().getPlugin("Raxen")
                    )
                ).getManager()
                    .getPlayerManager();
            debug(
                main,
                e.getEntity().getName(),
                e.getEntity().getType().toString(),
                e.getDamager().getType().toString(),
                e.getDamager().getName()
            );
            if (e.getDamager() instanceof Player playerDamager) {
                strength = pm.getStrength().get(playerDamager);
                itemStrength = pm.getItemStrength().get(playerDamager);
            } else {
                Entity entityDamager = e.getDamager();
                PersistentDataContainer data =
                    entityDamager.getPersistentDataContainer();
                if (
                    data.has(
                        entityNamespacedKey.strength,
                        PersistentDataType.INTEGER
                    )
                ) {
                    strength =
                        data.get(
                            entityNamespacedKey.strength,
                            PersistentDataType.INTEGER
                        );
                }
                itemStrength =
                    pm.getItemStrength().getItem((LivingEntity) entityDamager);
            }
            if (e.getEntity() instanceof Player playerVictim) {
                me.unurled.raxen.components.entity.player.attributes.Attributes attributes =
                    new me.unurled.raxen.components.entity.player.attributes.Attributes(
                        main
                    );
                defense = pm.getDefense().get(playerVictim);
                health = pm.getHealth().get(playerVictim);
                itemDefense = pm.getItemDefense().get(playerVictim);
                itemHealth = pm.getItemHealth().get(playerVictim);
            } else {
                Entity entityVictim = e.getEntity();
                PersistentDataContainer data =
                    entityVictim.getPersistentDataContainer();
                if (
                    data.has(
                        entityNamespacedKey.defense,
                        PersistentDataType.INTEGER
                    )
                ) {
                    defense =
                        data.get(
                            entityNamespacedKey.defense,
                            PersistentDataType.INTEGER
                        );
                }
                if (
                    data.has(
                        entityNamespacedKey.health,
                        PersistentDataType.INTEGER
                    )
                ) {
                    health =
                        data.get(
                            entityNamespacedKey.health,
                            PersistentDataType.INTEGER
                        );
                }
                itemDefense =
                    pm.getItemDefense().getItem((LivingEntity) entityVictim);
                itemHealth =
                    pm.getItemHealth().getItem((LivingEntity) entityVictim);
            }
            debug(
                main,
                initDamage.toString(),
                itemDefense.toString(),
                strength.toString()
            );
            initDamage = (5 + itemStrength) * (1 + (strength / 100));
            damage = initDamage;
            defense = defense + itemDefense;
            debug(main, String.valueOf(damage));
            defense = defense / (defense + 100);
            debug(main, String.valueOf(damage));
            debug(main, String.valueOf(defense));
            Integer health_with_defense = health * (1 + (defense / 100));
            debug(main, String.valueOf(damage));
            debug(main, String.valueOf(health));
            debug(main, String.valueOf(health_with_defense));
            if (damage >= health_with_defense) {
                debug(main, "Killed entity normally.");
                e.setDamage(
                    Objects
                        .requireNonNull(
                            e
                                .getEntity()
                                .getType()
                                .getDefaultAttributes()
                                .getAttribute(Attribute.GENERIC_MAX_HEALTH)
                        )
                        .getDefaultValue()
                );
            } else {
                debug(main, "Applying damage to entity.");
                if (defense == 0) {
                    health = health_with_defense - damage;
                } else {
                    health = health_with_defense - health - damage;
                }
                if (e.getEntity() instanceof Player playerVictim) {
                    me.unurled.raxen.components.entity.player.attributes.Attributes attributes =
                        new me.unurled.raxen.components.entity.player.attributes.Attributes(
                            main
                        );
                    pm.getHealth().set(playerVictim, health);
                    playerVictim.setHealth(health.doubleValue() / 5);
                } else {
                    Entity entityVictim = e.getEntity();
                    pm.getHealth().set(entityVictim, health);
                }
                debug(main, health.toString());
            }
        }
    }

    /**
     * damage made by blocks on entity
     *
     * @param e
     */
    @Deprecated
    // @EventHandler
    public void entityDamageByBlock(EntityDamageByBlockEvent e) {
        e.setDamage(0);
        if (e.getEntity() instanceof Player) {
            Player player = (Player) e.getEntity();
        }
    }
}
