package me.unurled.raxen.listener.player;

import com.destroystokyo.paper.event.player.PlayerArmorChangeEvent;
import de.tr7zw.nbtapi.NBTItem;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.PlayerUtils;
import me.unurled.raxen.components.entity.player.attributes.Attributes;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

public class ArmorEvent implements Listener {

    private Raxen main;

    public ArmorEvent(Raxen main) {
        this.main = main;
    }

    /**
     * when player changes armor, calculates new stats for player and setting it
     * @param e
     */
    @EventHandler
    public void ArmorChangeEvent(PlayerArmorChangeEvent e) {
        Player player = e.getPlayer();
        PlayerManager pm =
            ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager()
                .getPlayerManager();
        Entity entity = player;
        Attributes attributes = new Attributes(main);
        if (
            e.getOldItem() != null && e.getOldItem().getType() != Material.AIR
        ) {
            ItemStack oldItem = e.getOldItem();
            NBTItem nbti = new NBTItem(oldItem);
            if (nbti.hasTag("SPEED")) {
                pm.getSpeed().remove(entity, nbti.getInteger("SPEED"));
            }
            if (nbti.hasTag("HEALTH")) {
                pm.getHealth().remove(entity, nbti.getInteger("HEALTH"));
            }
            if (nbti.hasTag("DEFENSE")) {
                pm.getDefense().remove(entity, nbti.getInteger("DEFENSE"));
            }
            if (nbti.hasTag("STRENGTH")) {
                pm.getStrength().remove(entity, nbti.getInteger("STRENGTH"));
            }
        }
        if (
            e.getNewItem() != null && e.getNewItem().getType() != Material.AIR
        ) {
            ItemStack newItem = e.getNewItem();
            NBTItem nbti = new NBTItem(newItem);
            if (nbti.hasTag("SPEED")) {
                pm.getSpeed().add(entity, nbti.getInteger("SPEED"));
            }
            if (nbti.hasTag("HEALTH")) {
                pm.getHealth().add(entity, nbti.getInteger("HEALTH"));
            }
            if (nbti.hasTag("DEFENSE")) {
                pm.getDefense().add(entity, nbti.getInteger("DEFENSE"));
            }
            if (nbti.hasTag("STRENGTH")) {
                pm.getStrength().add(entity, nbti.getInteger("STRENGTH"));
            }
        }
        PlayerUtils.updateSkills(main, player);
    }
}
