package me.unurled.raxen.listener.player;

import static me.unurled.raxen.utils.Utils.debug;

import de.tr7zw.nbtapi.NBTItem;
import java.lang.reflect.InvocationTargetException;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.Attributes.Attribute;
import me.unurled.raxen.components.entity.player.PlayerUtils;
import me.unurled.raxen.components.entity.player.attributes.Attributes;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.inventory.ItemStack;

public class ItemHandEvent implements Listener {

    private Raxen main;

    public ItemHandEvent(Raxen main) {
        this.main = main;
    }

    /**
     * when player have something in hand, change and add new stats
     * @param e
     */
    @EventHandler
    public void ItemHeldEvent(PlayerItemHeldEvent e) {
        Player player = e.getPlayer();
        PlayerManager pm =
            ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager()
                .getPlayerManager();
        Entity entity = player;
        Attributes attributes = new Attributes(main);
        ItemStack oldItem = player.getInventory().getItem(e.getPreviousSlot());
        ItemStack newItem = player.getInventory().getItem(e.getNewSlot());
        if (oldItem != null && oldItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(oldItem);
            for (String s : Attributes.getNameList()) {
                if (nbti.hasTag(s.toUpperCase())) {
                    java.lang.reflect.Method method = null;
                    try {
                        method = pm.getClass().getMethod("getItem" + s);
                    } catch (
                        SecurityException | NoSuchMethodException exception
                    ) {}
                    if (method != null) {
                        me.unurled.raxen.components.entity.Attributes.Attribute attribute =
                            null;
                        try {
                            attribute = (Attribute) method.invoke(pm);
                        } catch (
                            InvocationTargetException
                            | IllegalAccessException ignored
                        ) {}
                        if (attribute != null) {
                            attribute.remove(
                                player,
                                nbti.getInteger(s.toUpperCase())
                            );
                            debug(
                                "removed " +
                                s +
                                " for player " +
                                player.getName()
                            );
                        }
                    }
                }
            }
            /*if(nbti.hasTag("SPEED")) {
                pm.getItemSpeed().remove(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasTag("HEALTH")) {
                pm.getItemHealth().remove(player, nbti.getInteger("HEALTH"));
            }
            if(nbti.hasTag("DEFENSE")) {
                pm.getItemDefense().remove(player, nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasTag("STRENGTH")) {
                pm.getItemStrength().remove(player, nbti.getInteger("STRENGTH"));
            }*/
        }
        if (newItem != null && newItem.getType() != Material.AIR) {
            NBTItem nbti = new NBTItem(newItem);
            for (String s : Attributes.getNameList()) {
                if (nbti.hasTag(s.toUpperCase())) {
                    java.lang.reflect.Method method = null;
                    try {
                        method = pm.getClass().getMethod("getItem" + s);
                    } catch (
                        SecurityException | NoSuchMethodException exception
                    ) {}
                    if (method != null) {
                        me.unurled.raxen.components.entity.Attributes.Attribute attribute =
                            null;
                        try {
                            attribute = (Attribute) method.invoke(pm);
                        } catch (
                            InvocationTargetException
                            | IllegalAccessException ignored
                        ) {}
                        if (attribute != null) {
                            attribute.add(
                                player,
                                nbti.getInteger(s.toUpperCase())
                            );
                            debug(
                                "add " + s + " for player " + player.getName()
                            );
                        }
                    }
                }
            }
            /* if(nbti.hasTag("SPEED")) {
                pm.getItemSpeed().add(player, nbti.getInteger("SPEED"));
            }
            if(nbti.hasTag("HEALTH")) {
                pm.getItemHealth().add(player, nbti.getInteger("HEALTH"));

            }
            if(nbti.hasTag("DEFENSE")) {
                pm.getItemDefense().add(player, nbti.getInteger("DEFENSE"));

            }
            if(nbti.hasTag("STRENGTH")) {
                pm.getItemStrength().add(player, nbti.getInteger("STRENGTH"));
            }*/
        }
        PlayerUtils.updateSkills(main, player);
    }
}
