package me.unurled.raxen.listener.player;

import java.io.IOException;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.config.PlayerConfig;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerQuitEvent;

public class LeaveEvent implements Listener {

    private final PlayerConfig playerConfig;
    private PlayerManager playerManager;

    public LeaveEvent(Raxen main) {
        this.playerConfig = main.getPlayerConfig();
        this.playerManager = main.getManager().getPlayerManager();
    }

    /**
     * when player leaves, saves everything
     *
     * @param e
     * @throws IOException
     */
    @EventHandler
    public void PlayerLeaveEvent(PlayerQuitEvent e) throws IOException {
        Player player = e.getPlayer();
        playerConfig.savePlayerConfig(player);
        playerManager.getRaxenPlayer(player).isRaxenPlayer(false);
        playerManager.unRegisterActionBar(player);
    }
}
