package me.unurled.raxen.manager;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.manager.entity.EntityManager;
import me.unurled.raxen.manager.entity.ItemManager;
import me.unurled.raxen.manager.entity.LootManager;
import me.unurled.raxen.manager.entity.PartyManager;
import me.unurled.raxen.manager.entity.PlayerManager;
import me.unurled.raxen.manager.entity.SpellManager;
import me.unurled.raxen.manager.entity.StorageManager;
import me.unurled.raxen.manager.server.BuildManager;
import me.unurled.raxen.manager.server.CommandManager;
import me.unurled.raxen.manager.server.DungeonsManager;
import me.unurled.raxen.manager.server.GlyphManager;
import me.unurled.raxen.manager.server.LibsManager;
import me.unurled.raxen.manager.server.ListenerManager;
import me.unurled.raxen.manager.server.ResourcePackManager;
import me.unurled.raxen.manager.server.TutorialManager;
import me.unurled.raxen.manager.server.WorldManager;
import me.unurled.raxen.utils.libs.Multiverse;

/**
 * Manager class, it enables all features of the plugin. From commands, to Item and worlds, it links
 * all of them together.
 */
public class Manager {

    @Getter
    private WorldManager worldManager;

    @Getter
    private StorageManager storageManager;

    @Getter
    private PlayerManager playerManager;

    @Getter
    private ListenerManager listenerManager;

    @Getter
    private CommandManager commandManager;

    @Getter
    private ItemManager itemManager;

    @Getter
    private ResourcePackManager resourcePackManager;

    @Getter
    private EntityManager entityManager;

    @Getter
    private LootManager lootManager;

    @Getter
    private LibsManager libsManager;

    @Getter
    private DungeonsManager dungeonsManager;

    @Getter
    private Multiverse multiverse;

    @Getter
    private TutorialManager tutorialManager;

    @Getter
    private PartyManager partyManager;

    @Getter
    private SpellManager spellManager;

    @Getter
    private GlyphManager glyphManager;

    @Getter
    private BuildManager buildManager;

    /**
     * Create an instance of all managers.
     *
     * @param main Raxen
     */
    public void set(Raxen main) {
        libsManager = new LibsManager(main);
        multiverse = new Multiverse();

        worldManager = new WorldManager(main);
        storageManager = new StorageManager(main);

        itemManager = new ItemManager(main);
        playerManager = new PlayerManager(main);
        listenerManager = new ListenerManager(main);
        commandManager = new CommandManager(main);
        resourcePackManager = new ResourcePackManager(main);
        entityManager = new EntityManager(main);
        lootManager = new LootManager(main);
        dungeonsManager = new DungeonsManager(main);
        tutorialManager = new TutorialManager();
        partyManager = new PartyManager(main);
        spellManager = new SpellManager(main);
        glyphManager = new GlyphManager(main);
        buildManager = new BuildManager(main);
    }
}
