package me.unurled.raxen.manager.entity;

import java.util.HashMap;
import java.util.UUID;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.player.RaxenPlayer;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

public class SpellManager {

    static Raxen main;

    public HashMap<UUID, Caster> casters = new HashMap<>();
    public HashMap<UUID, Long> lastPress = new HashMap<>();

    public boolean isCasting(Player player) {
        if (!casters.containsKey(player.getUniqueId())) {
            return false;
        }
        Caster caster = casters.get(player.getUniqueId());
        return caster.state != CastState.NONE;
    }

    public SpellManager(Raxen main) {
        SpellManager.main = main;
    }

    public enum CastState {
        NONE(""), R("Right"), RL("Right-Left"), RLR("Right-Left-Right"), RLL("Right-Left-Left"), RR(
            "Right-Right"), RRL("Right-Right-Left"), RRR("Right-Right-Right");
        public String string;

        @Override
        public String toString() {
            return string;
        }

        CastState(String s) {
            this.string = s;
        }
    }

    public static class Caster {

        public CastState state = CastState.NONE;
        public int pressCount = 0;

        public void press(boolean left) {
            pressCount++;
            final int lastPressCount = pressCount;
            Bukkit.getScheduler().scheduleSyncDelayedTask(main, new Runnable() {
                @Override
                public void run() {
                    if (lastPressCount != pressCount) {
                        return;
                    }
                    clear();
                }
            }, 20L);
            switch (state) {
                case NONE:
                    if (!left) {
                        state = CastState.R;
                    }
                    break;
                case R:
                    if (!left) {
                        state = CastState.RR;
                    } else {
                        state = CastState.RL;
                    }
                    break;
                case RL:
                    if (left) {
                        state = CastState.RLL;
                    } else {
                        state = CastState.RLR;
                    }
                    break;
                case RR:
                    if (!left) {
                        state = CastState.RRR;
                    } else {
                        state = CastState.RRL;
                    }
                    break;
                case RLL:
                case RLR:
                case RRL:
                case RRR:
                    state = CastState.NONE;
                    break;
                default:
                    break;
            }
        }

        public void clear() {
            state = CastState.NONE;
        }
    }

    public static boolean isSpellWeapon(ItemStack it) {
        if (it == null || it.getType() == Material.AIR) {
            return false;
        }
        return true;
    }

    public void click(Player p, boolean left) {
        if (p.isGliding()) {
            return;
        }
        if (!casters.containsKey(p.getUniqueId())) {
            casters.put(p.getUniqueId(), new Caster());
        }
        RaxenPlayer rx = main.getManager().getPlayerManager().getRaxenPlayer(p);
        ItemStack it = p.getEquipment().getItemInMainHand();
        boolean spellWep = false;
        if (it != null) {
            spellWep = isSpellWeapon(it);
        }
        if (rx != null) {
            if (lastPress.containsKey(p.getUniqueId())) {
                if (System.currentTimeMillis() - lastPress.get(p.getUniqueId()) < 50) {
                    return;
                }
            }
            lastPress.put(p.getUniqueId(), System.currentTimeMillis());
            final Caster c = casters.get(p.getUniqueId());
            if (spellWep) {
                c.press(left);
            } else {
                c.clear();
            }
            // TODO: checkState
        }
    }

    public void checkState(Player p, RaxenPlayer rx, Caster c) {
        rx.updateHealthManaDisplay();
        ItemStack it = p.getEquipment().getItemInMainHand();
        if (c.state == CastState.RLL) {
            if (it != null) {
                
            }
        }
    }
}
