package me.unurled.raxen.manager.server;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.utils.libs.CitizensApi;
import me.unurled.raxen.utils.libs.MongoDB;
import me.unurled.raxen.utils.libs.Mysql;
import me.unurled.raxen.utils.libs.PlaceHolderAPI;
import me.unurled.raxen.utils.libs.Vault;

public class LibsManager {

    @Getter
    private final ProtocolManager protocolManager;

    @Getter
    private final Vault vault;

    @Getter
    private final MongoDB mongoDB;

    @Getter
    private static Mysql mysql;

    @Getter
    private PlaceHolderAPI placeHolderAPI;

    @Getter
    private CitizensApi citizens;


    public LibsManager(Raxen main) {
        this.vault = new Vault(main);
        this.protocolManager = new ProtocolManager(main);
        this.mongoDB = new MongoDB();
        this.placeHolderAPI = new PlaceHolderAPI(main);
        this.citizens = new CitizensApi(main);
    }
}
