package me.unurled.raxen.manager.server;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.listener.entity.DamageEntity;
import me.unurled.raxen.listener.entity.SpawnEvent;
import me.unurled.raxen.listener.player.ArmorEvent;
import me.unurled.raxen.listener.player.ClickBlockEvent;
import me.unurled.raxen.listener.player.CloseInventoryEvent;
import me.unurled.raxen.listener.player.FoodLevelEvent;
import me.unurled.raxen.listener.player.InteractEvent;
import me.unurled.raxen.listener.player.ItemHandEvent;
import me.unurled.raxen.listener.player.JoinEvent;
import me.unurled.raxen.listener.player.LeaveEvent;
import me.unurled.raxen.listener.player.ServerPingEvent;
import me.unurled.raxen.listener.player.SpellsEvent;
import me.unurled.raxen.listener.player.TransactionEvent;
import me.unurled.raxen.utils.Reload;
import org.bukkit.plugin.PluginManager;

public class ListenerManager {

    private final Raxen main;
    private final PluginManager pm;

    @Getter
    private ServerPingEvent serverPingEvent;

    public ListenerManager(Raxen main) {
        this.main = main;
        this.pm = main.getPm();
        this.serverPingEvent = new ServerPingEvent(main);
    }

    /**
     * register/addd listener events
     */
    public void register() {
        this.pm.registerEvents(new JoinEvent(main), main);
        this.pm.registerEvents(new LeaveEvent(main), main);
        this.pm.registerEvents(new ArmorEvent(main), main);
        this.pm.registerEvents(new ItemHandEvent(main), main);
        this.pm.registerEvents(new Reload(), main);
        this.pm.registerEvents(new TransactionEvent(main), main);
        this.pm.registerEvents(
            main
                .getManager()
                .getCommandManager()
                .getItemListCommand()
                .getItemListGui(),
            main
        );
        this.pm.registerEvents(new DamageEntity(main), main);
        this.pm.registerEvents(new SpawnEvent(main), main);
        this.pm.registerEvents(new ClickBlockEvent(main), main);
        this.pm.registerEvents(serverPingEvent, main);
        this.pm.registerEvents(new CloseInventoryEvent(), main);
        this.pm.registerEvents(new InteractEvent(), main);
        this.pm.registerEvents(new FoodLevelEvent(), main);
        this.pm.registerEvents(new SpellsEvent(main), main);
    }
}
