package me.unurled.raxen.manager.server;

import com.comphenix.protocol.PacketType;
import com.comphenix.protocol.PacketType.Play.Server;
import com.comphenix.protocol.events.ListenerPriority;
import com.comphenix.protocol.events.PacketAdapter;
import com.comphenix.protocol.events.PacketContainer;
import com.comphenix.protocol.events.PacketEvent;
import com.comphenix.protocol.wrappers.BlockPosition;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.clientbuild.Builds;
import org.bukkit.Location;
import org.bukkit.entity.Player;

public class ProtocolManager {

    private final Raxen main;
    private com.comphenix.protocol.ProtocolManager manager;

    public ProtocolManager(Raxen main) {
        this.main = main;
        this.manager = main.getProtocolManager();
    }

    public void listen() {
        manager.addPacketListener(
            new PacketAdapter(
                main,
                ListenerPriority.NORMAL,
                PacketType.Play.Client.BLOCK_DIG
            ) {
                @Override
                public void onPacketReceiving(PacketEvent event) {
                    Player player = event.getPlayer();
                    PacketContainer packet = event.getPacket();
                    // if(player.)
                }
            }
        );
        manager.addPacketListener(
            new PacketAdapter(main, ListenerPriority.NORMAL, Server.BLOCK_CHANGE) {
                @Override
                public void onPacketSending(PacketEvent event) {
                    PacketContainer packet = event.getPacket();
                    BlockPosition pos = packet.getBlockPositionModifier().read(0);
                    Location loc;
                    if (main.getManager().getBuildManager().isABuild(
                         loc = new Location(event.getPlayer().getWorld(), pos.getX(), pos.getY(),
                            pos.getZ()))) {
                        Builds build = main.getManager().getBuildManager().getBuildsByLocation(loc);
                        if (!main.getManager().getBuildManager().isInPlayerList(build, event.getPlayer())) {
                            event.setCancelled(true);
                        }
                    }
                    super.onPacketSending(event);
                }
            });
    }
}
