package me.unurled.raxen.utils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.format.Style;
import org.jetbrains.annotations.NotNull;

final class ComponentSplit {

    private ComponentSplit() {
    }

    static @NotNull List<Component> split(final @NotNull Component self,
        final @NotNull Component separator) {
        if (self.children().size() == 0) {
            return Collections.singletonList(self);
        }

        final List<Component> result = new ArrayList<>();
        final Component root = self.children(Collections.emptyList());
        TextComponent.Builder build = Component.text();
        build.append(root.style(Style.empty()));
        for (final Component child : self.children()) {
            if (child.equals(separator)) {
                result.add(build.build().applyFallbackStyle(root.style()));
                build = Component.text();
            } else {
                build.append(child);
            }
        }
        result.add(build.build().applyFallbackStyle(root.style()));
        return result;
    }
}
