package me.unurled.raxen.utils;

import org.bukkit.Location;

public class Math {

    /**
     * author: Edasaki Generates a random integer in the range [a, b].
     *
     * @param a minimum
     * @param b maximum
     */
    public static int randInt(int a, int b) {
        return (int) (java.lang.Math.random() * (b - a + 1) + a);
    }

    /**
     * author: Edasaki Returns the Manhattan distance in the x-z plane between locations a and b.
     *
     * @param a
     * @param b
     * @return distance between a and b.
     */
    public static double flatDistance(Location a, Location b) {
        if (!a.getWorld().equals(b.getWorld())) {
            return Double.MAX_VALUE;
        }
        double sum = 0;
        sum += java.lang.Math.abs(a.getX() - b.getX());
        sum += java.lang.Math.abs(a.getZ() - b.getZ());
        return sum;
    }

}
